/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package reprezentaciagrafu;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 *
 * @author majer
 */
public class Graf {
    private int aN; // PocetVrcholov
    private int aM; // PocetHran
            
    private int[][] aH; // pole hran
    
    public Graf( int paPocetVrcholov, int paPocetHran )
    {
        aN = paPocetVrcholov;
        aM = paPocetHran;
        
        aH = new int[1+3][1+aM];
    }
    
    public static Graf Nacitaj( String paNazovSuboru ) throws FileNotFoundException
    {
        Scanner scanner = new Scanner( new File( paNazovSuboru) );

        int pocetVrcholov = scanner.nextInt();
        int pocetHran = scanner.nextInt();
        Graf g = new Graf(pocetVrcholov, pocetHran);

        for (int i = 1; i <= pocetHran; i++ )
        {
            int u = scanner.nextInt();
            int v = scanner.nextInt();
            int c = scanner.nextInt();
            
            g.aH[1][i] = u;
            g.aH[2][i] = v;
            g.aH[3][i] = c;
        }
        
        return g;
    }
    
    public void VypisGraf()
    {
        System.out.println("Pocet vrcholov = " + aN );
        System.out.println("Pocet hran = " + aM );
        for (int i = 1; i <= 3; i++)
        {
            for (int j = 1; j <= aM; j++ )
            {
                System.out.print("\t" + aH[i][j]);
            }
            System.out.println();
        }
    }
    
    public void vypisGraf2()
    {
        System.out.println("G = (V,H)" );
        
        System.out.print("V = {" );
        for (int i = 1; i <= aN; i++ )
        {
            if (i > 1) System.out.print(",");
            System.out.print(""+ i);
        }
        System.out.println("}");
        
        System.out.print("H = {" );
        for (int j = 1; j <= aM; j++ )
        {
            if (j > 1) System.out.print(",");
            System.out.print("{" + aH[1][j] + "," + aH[2][j] + "}");
        }
        System.out.println("}");
    }
    
    public int stupenVrchola(int v)
    {
        // idem spocitat pocet incidentnych hran 
        int pocet = 0;
        for (int j = 1; j <= aM; j++)
        {
            if (aH[1][j] == v || aH[2][j] == v)
            {
                // nasiel som incidentnu hranu
                pocet++;
            }
        }
        
        return pocet;
    }
}
